local EventWatcher = CreateFrame("Frame");
local TrashCan = CreateFrame("Frame");

--Set DunningUI V2.0.0
DunningTrashCan = CreateFrame("Frame", "DunningTrashCan", UIParent);
DunningTrashCan:Hide();

--Set variables for load
for i = 1, NUM_CHAT_WINDOWS do
    _G["ChatFrame"..i]:SetClampRectInsets(-35, 35, 35, -35);
end

--Set hooksecurefunc(ExpBarMixin, ArtifactBarMixin, HonorBarMixin)
hooksecurefunc(ExpBarMixin, "Update", ExpBarMixin.UpdateCurrentText);
hooksecurefunc(ArtifactBarMixin, "Update", ArtifactBarMixin.UpdateOverlayFrameText);
hooksecurefunc(HonorBarMixin, "Update", HonorBarMixin.UpdateOverlayFrameText);

--Set remove
function Remove(name)
    if ( name ) then
        name:SetParent(DunningTrashCan);
    end
end

--Set move
function Move(name, p1, parent, p2, x, y)
    if ( name ) then
        name:ClearAllPoints();
        name:SetPoint(p1, parent, p2, x, y);
    end
end

--Set Nameplate(20210129_Fri_updated)
local function SetNameplates()
    if ( not DunningVariables[1] ) then
        return
    end
    for _, i in pairs({"nameplateMinScale", "nameplateSelectedScale"}) do
        SetCVar(i, 1);
    end
    hooksecurefunc("CompactUnitFrame_OnLoad", function(self)
            self:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
            if ( self.BuffFrame ) then
                self.name:SetFont("Fonts\\2002.TTF", 12);
                self.name:SetShadowOffset(1, -1);
            end
    end);
    hooksecurefunc(NameplateBuffContainerMixin, "UpdateAnchor", function(self)
            self:SetPoint("BOTTOM", self:GetParent().name, "TOP", 0, 0);
    end);
    hooksecurefunc("CompactUnitFrame_UpdateName", function(frame)
            frame.name:SetText(GetUnitName(frame.unit, true));
            frame.name:Show();
    end);
    local function setup(frame)
        local isTanking = UnitDetailedThreatSituation("player", frame.displayedUnit);
        if ( not isTanking ) then
            frame.name:SetVertexColor(1, 1, 1, 1);
        else
            frame.name:SetVertexColor(1, 0, 0, 1);
        end
    end
    hooksecurefunc("CompactUnitFrame_UpdateName", setup);
    hooksecurefunc("CompactUnitFrame_UpdateAggroHighlight", setup);
    hooksecurefunc("CompactUnitFrame_UpdateHealthBorder", function(frame)
        if ( frame.optionTable.selectedBorderColor ) then
            if ( UnitIsUnit(frame.displayedUnit, "target") ) then
                frame.healthBar.border:SetVertexColor(1, 1, 1, 1);
            elseif ( UnitIsUnit(frame.displayedUnit, "mouseover") ) then
                frame.healthBar.border:SetVertexColor(1, 1, 0, 1);
                frame:SetScript("OnUpdate", function(self, elapsed)
                        if ( self.optionTable.selectedBorderColor ) then
                            if ( UnitIsUnit(self.displayedUnit, "target") ) then
                                self:SetScript("OnUpdate", nil);
                                self.healthBar.border:SetVertexColor(1, 1, 1, 1);
                            elseif ( not UnitIsUnit(self.displayedUnit, "mouseover") ) then
                                self:SetScript("OnUpdate", nil);
                                self.healthBar.border:SetVertexColor(0, 0, 0, 0);
                            end
                        end
                end);
            else
                frame.healthBar.border:SetVertexColor(0, 0, 0, 0);
            end
        end
    end);
    hooksecurefunc("CompactUnitFrame_OnEvent", function(self, event, ...)
        if ( event == "UPDATE_MOUSEOVER_UNIT" ) then
            CompactUnitFrame_UpdateHealthBorder(self);
        end
    end);
end

--Set MainMenu(20210129_Fri_updated)
local function SetMainMenu()
    if ( not DunningVariables[13] ) then
        return
    end
    for _, name in pairs({MainMenuBarArtFrame.LeftEndCap, MainMenuBarArtFrame.RightEndCap, MainMenuBarArtFrameBackground.QuickKeybindBottomShadow, MainMenuBarArtFrameBackground.QuickKeybindRightShadow, MainMenuBarArtFrameBackground.QuickKeybindGlowLarge, MainMenuBarArtFrameBackground.QuickKeybindGlowSmall, MainMenuBarArtFrameBackground.BackgroundLarge, MainMenuBarArtFrameBackground.BackgroundSmall, MainMenuBarArtFrame.PageNumber, ActionBarUpButton, ActionBarDownButton, MultiBarBottomRight.QuickKeybindGlow, MicroButtonAndBagsBar.MicroBagBar, SlidingActionBarTexture0, SlidingActionBarTexture1, PossessBackground1, PossessBackground2, StanceBarLeft, StanceBarMiddle, StanceBarRight, StatusTrackingBarManager.SingleBarLarge, StatusTrackingBarManager.SingleBarLargeUpper, StatusTrackingBarManager.SingleBarSmall, StatusTrackingBarManager.SingleBarSmallUpper}) do
        Remove(name);
    end
    hooksecurefunc("CovenantSanctum_LoadUI", function()
        Remove(CovenantSanctumFrame.UpgradesTab.BagsGlowFrame);
    end)
    for _, name in pairs({MainMenuBar, MainMenuBarArtFrame, MicroButtonAndBagsBar, PossessBarFrame, StanceBarFrame, MultiCastActionBarFrame, PetActionBarFrame, MultiBarLeft, MultiBarRight, MultiBarBottomLeft, MultiBarBottomRight, StatusTrackingBarManager}) do
        name:SetFrameStrata("MEDIUM");
        name:EnableMouse(false);
    end
    for _, text in pairs({"ActionButton", "MultiBarBottomLeftButton", "MultiBarBottomRightButton", "MultiBarLeftButton", "MultiBarRightButton", "PossessButton", "StanceButton", "MultiCastActionButton", "PetActionButton"}) do
        for i = 1, 12 do
            local name = _G[text..i];
            if ( name ) then
                name:SetScale(1);
                name:SetSize(38, 38);
                name:GetNormalTexture():SetPoint("TOPLEFT", name, "TOPLEFT", -12, 12);
                name:GetNormalTexture():SetPoint("BOTTOMRIGHT", name, "BOTTOMRIGHT", 13, -13);
                Remove(_G[text..i.."FloatingBG"]);
                Remove(_G[text..i.."Name"]);
            end
        end
    end
    for _, name in pairs({MainMenuBarBackpackButton, CharacterBag0Slot, CharacterBag1Slot, CharacterBag2Slot, CharacterBag3Slot}) do
        name:SetScale(0.9);
        name:SetSize(30, 30);
        Remove(name:GetNormalTexture());
    end
    for _, name in pairs({MainMenuBarVehicleLeaveButton, PossessBarFrame, StanceBarFrame, MultiCastActionBarFrame, PetActionBarFrame}) do
        name:SetScale(0.7);
    end
    MainMenuBarVehicleLeaveButton:SetSize(36, 36);
    Move(MainMenuBarArtFrameBackground, "BOTTOM", UIParent, "BOTTOM", 0, 0);
    Move(ActionButton1, "BOTTOMRIGHT", MainMenuBarArtFrameBackground, "BOTTOM", -213, 4);
    Move(MultiBarBottomLeftButton1, "BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 6);
    Move(MultiBarBottomRightButton1, "BOTTOMLEFT", MultiBarBottomLeftButton1, "TOPLEFT", 0, 6);
    local anchor = "ActionButton";
    if ( SHOW_MULTI_ACTIONBAR_2 ) then
        anchor = "MultiBarBottomRightButton";
    elseif ( SHOW_MULTI_ACTIONBAR_1 ) then
        anchor = "MultiBarBottomLeftButton";
    end
    Move(PossessButton1, "BOTTOMLEFT",  _G[anchor..1], "TOPLEFT", 0, 6);
    Move(StanceButton1, "BOTTOMLEFT",  _G[anchor..1], "TOPLEFT", 0, 6);
    Move(MultiCastActionButton1, "BOTTOMLEFT",  _G[anchor..1], "TOPLEFT", 0, 6);
    Move(PetActionButton10, "BOTTOMRIGHT",  _G[anchor..12], "TOPRIGHT", 0, 6);
    for i = 2, 12 do
        Move(_G["ActionButton"..i], "LEFT", _G["ActionButton"..i-1], "RIGHT", 6, 0);
        Move(_G["MultiBarBottomLeftButton"..i], "LEFT", _G["MultiBarBottomLeftButton"..i-1], "RIGHT", 6, 0);
        Move(_G["MultiBarBottomRightButton"..i], "LEFT", _G["MultiBarBottomRightButton"..i-1], "RIGHT", 6, 0);
        Move(_G["PossessButton"..i], "LEFT", _G["PossessButton"..i-1], "RIGHT", 6, 0);
        Move(_G["StanceButton"..i], "LEFT", _G["StanceButton"..i-1], "RIGHT", 6, 0);
        Move(_G["MultiCastActionButton"..i], "LEFT", _G["MultiCastActionButton"..i-1], "RIGHT", 6, 0);
        Move(_G["PetActionButton"..11-i], "RIGHT", _G["PetActionButton"..12-i], "LEFT", -6, 0);
    end
    hooksecurefunc("MainMenuBarVehicleLeaveButton_Update", function() Move(MainMenuBarVehicleLeaveButton, "BOTTOMLEFT", PossessButton1, "TOPLEFT", 0, 6) end);
    Move(MainMenuBarVehicleLeaveButton, "BOTTOMLEFT", PossessButton1, "TOPLEFT", 0, 6);
    Move(CharacterBag0Slot, "BOTTOMRIGHT", MainMenuBarBackpackButton, "BOTTOMLEFT", -2, 0);
    Move(MainMenuBarBackpackButtonCount, "BOTTOM", MainMenuBarBackpackButton, "BOTTOM", 0, 0);
    local function setup()
        local visibleBars = {};
        for i, bar in ipairs(StatusTrackingBarManager.bars) do
            if ( bar:ShouldBeVisible() ) then
                table.insert(visibleBars, bar);
            end
        end
        table.sort(visibleBars, function(left, right) return left:GetPriority() < right:GetPriority() end);
        if ( #visibleBars < 1 ) then
            Move(MainMenuBarBackpackButton, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -6, 40);
        else
            Move(MainMenuBarBackpackButton, "BOTTOMRIGHT",  UIParent, "BOTTOMRIGHT", -6, 56);
            Move(visibleBars[1], "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -6, 39);
            Move(visibleBars[1].OverlayFrame.Text, "CENTER", visibleBars[1].StatusBar, "CENTER", 0, 1);
            visibleBars[1].OverlayFrame:SetFrameStrata("MEDIUM");
            visibleBars[1]:SetSize(285, 15);
            visibleBars[1].StatusBar:SetSize(285, 15);
            if ( visibleBars[1].ExhaustionLevelFillBar ) then
                Move(visibleBars[1].ExhaustionLevelFillBar, "TOPLEFT", visibleBars[1], "TOPLEFT", 0, 0);
                visibleBars[1].ExhaustionLevelFillBar:SetSize(285, 15);
            end
        end
        if ( #visibleBars > 1 ) then
            Move(MainMenuBarBackpackButton, "BOTTOMRIGHT",  UIParent, "BOTTOMRIGHT", -6, 72);
            Move(visibleBars[2], "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -6, 55);
            Move(visibleBars[2].OverlayFrame.Text, "CENTER", visibleBars[2].StatusBar, "CENTER", 0, 1);
            visibleBars[2].OverlayFrame:SetFrameStrata("MEDIUM");
            visibleBars[2]:SetSize(285, 15);
            visibleBars[2].StatusBar:SetSize(285, 15);
            if ( visibleBars[2].ExhaustionLevelFillBar ) then
                Move(visibleBars[2].ExhaustionLevelFillBar, "TOPLEFT", visibleBars[2], "TOPLEFT", 0, 0);
                visibleBars[2].ExhaustionLevelFillBar:SetSize(285, 15);
            end
        end
    end
    hooksecurefunc(StatusTrackingBarManager, "UpdateBarsShown", setup);
    setup();
    ConsoleExec("xpBarText 1");
end

--Set chatframes(20210129_Fri_updated)
local function SetChatframes()
    if ( not DunningVariables[14] ) then
        return
    end
    for i = 1, NUM_CHAT_WINDOWS do
        for _, text in pairs({"ButtonFrameMinimizeButton", "ButtonFrameBackground", "ButtonFrameTopLeftTexture", "ButtonFrameBottomLeftTexture", "ButtonFrameTopRightTexture", "ButtonFrameBottomRightTexture", "ButtonFrameLeftTexture", "ButtonFrameRightTexture", "ButtonFrameBottomTexture", "ButtonFrameTopTexture"}) do
            Remove(_G["ChatFrame"..i..text]);
        end
        _G["ChatFrame"..i]:SetClampedToScreen(false);
    end
    hooksecurefunc("ChatFrame_OnLoad", function(self)
        self:SetClampedToScreen(false);
    end);
    Move(ChatFrame1, "BOTTOMLEFT", UIParent, "BOTTOMLEFT", 35, 35);
    ChatFrame1:SetUserPlaced(true);
    ChatFrame1.buttonFrame:ClearAllPoints();
    ChatFrame1.buttonFrame:SetPoint("TOPRIGHT", ChatFrame1.Background, "TOPLEFT", -3, -3);
    ChatFrame1.buttonFrame:SetPoint("BOTTOMRIGHT", ChatFrame1.Background, "BOTTOMLEFT", -3, 6);
    ChatFrameMenuButton:SetScript("OnClick", function(self, button, down)
        PlaySound(825);
        if ( not ChatMenu:IsShown() ) then
            ChatMenu:Show();
        else
            ChatMenu:Hide();
        end
    end);
    for _, name in pairs({"CHAT_MSG_SAY", "CHAT_MSG_WHISPER", "CHAT_MSG_YELL", "CHAT_MSG_GUILD", "CHAT_MSG_OFFICER", "GUILD_MOTD", "CHAT_MSG_BN_WHISPER", "CHAT_MSG_BN_CONVERSATION", "CHAT_MSG_BN_INLINE_TOAST_BROADCAST", "CHAT_MSG_PARTY", "CHAT_MSG_PARTY_LEADER", "CHAT_MSG_RAID", "CHAT_MSG_RAID_LEADER", "CHAT_MSG_INSTANCE_CHAT", "CHAT_MSG_INSTANCE_CHAT_LEADER", "CHAT_MSG_CHANNEL"}) do
        ChatFrame_AddMessageEventFilter(name, function(_, _, msg, ...)
            local newMsg, found = gsub(msg, "[^ \"£%^`¨{}%[%]\\|<>]+[^ '%-=%./,\"£%^`¨{}%[%]\\|<>%d]%.[^ '%-=%./,\"£%^`¨{}%[%]\\|<>%d][^ \"£%^`¨{}%[%]\\|<>]+", "|cff9999ff|Hurzurl~%1|h[%1]|h|r");
            if ( found > 0 ) then
                return false, newMsg, ...;
            end
            newMsg, found = gsub(msg, "^%x+[%.:]%x+[%.:]%x+[%.:]%x+[^ \"£%^`¨{}%[%]\\|<>]*", "|cff9999ff|Hurzurl~%1|h[%1]|h|r");
            if ( found > 0 ) then
                return false, newMsg, ...;
            end
            newMsg, found = gsub(msg, " %x+[%.:]%x+[%.:]%x+[%.:]%x+[^ \"£%^`¨{}%[%]\\|<>]*", "|cff9999ff|Hurzurl~%1|h[%1]|h|r");
            if ( found > 0 ) then
                return false, newMsg, ...;
            end
        end);
    end
    local old = ItemRefTooltip.SetHyperlink;
    function ItemRefTooltip:SetHyperlink(data, ...)
        local isURL, link = strsplit("~", data);
        if (( isURL ) and ( isURL == "urzurl" )) then
            local activeWindow = ChatEdit_GetActiveWindow();
            if ( activeWindow ) then
                activeWindow:SetText(link);
                ChatEdit_FocusActiveWindow();
                activeWindow:HighlightText();
            else
                activeWindow = ChatEdit_GetLastActiveWindow();
                activeWindow:Show();
                activeWindow:SetText(link);
                activeWindow:SetFocus();
                activeWindow:HighlightText();
            end
        else
            old(self, data, ...);
        end
    end
end

--Set NPC talking move top
local f = CreateFrame("Frame")

function f:OnEvent(event, addon)
	if addon == "Blizzard_TalkingHeadUI" then
		hooksecurefunc("TalkingHeadFrame_PlayCurrent", function()
		TalkingHeadFrame.ignoreFramePositionManager = true
		TalkingHeadFrame:ClearAllPoints()
		TalkingHeadFrame:SetPoint("TOP")
		end)
		self:UnregisterEvent(event)
	end
end

f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", f.OnEvent)

--Set Unitframes(20210129_Fri_updated)
local function SetUnitframes()
    if ( not DunningVariables[15] ) then
        return
    end
    PlayerFrame:UnregisterEvent("UNIT_COMBAT");
    PetFrame:UnregisterEvent("UNIT_COMBAT");
    for _, name in pairs({PlayerStatusTexture, PlayerAttackBackground, PlayerFrameFlash, PlayerStatusGlow, PlayerAttackGlow, PlayerRestGlow, PlayerHitIndicator, PetFrameFlash, PetAttackModeTexture, PetHitIndicator, TargetFrameFlash, FocusFrameFlash}) do
        Remove(name);
    end
    for _, name in pairs({PlayerFrameHealthBar, PlayerFrameManaBar, PlayerPVPIconHitArea, PetFrameHealthBar, PetFrameManaBar, TargetFrameHealthBar, TargetFrameManaBar, FocusFrameHealthBar, FocusFrameManaBar}) do
        name:EnableMouse(false);
    end
    hooksecurefunc("PlayerFrame_UpdateStatus", function()
            if (( not UnitHasVehiclePlayerFrameUI("player") ) and ( UnitAffectingCombat("player") )) then
                PlayerAttackIcon:Show();
                PlayerRestIcon:Hide();
            end
            if (( PlayerAttackIcon:IsShown() ) or ( PlayerRestIcon:IsShown() )) then
                PlayerLevelText:Hide();
            else
                PlayerLevelText:Show();
            end
    end);
    local function setup(textStatusBar)
        if (( textStatusBar == PlayerFrameHealthBar ) or ( textStatusBar == TargetFrameHealthBar )) then
            local current = textStatusBar:GetValue();
            local _, max = textStatusBar:GetMinMaxValues();
            if (( current > 0) and ( max > 0 )) then
                textStatusBar.TextString:SetFormattedText("%i%%   %s", ceil(current/max*100), AbbreviateLargeNumbers(current));
            end
        end
    end
    hooksecurefunc("TextStatusBar_UpdateTextString", setup);
    setup(PlayerFrameHealthBar);
    setup(TargetFrameHealthBar);

    -- CastBar
    CastingBarFrame:SetFrameStrata("FULLSCREEN_DIALOG");

    -- RaidFrames
    CompactUnitFrameProfilesGeneralOptionsFrameHeightSlider:SetMinMaxValues(16, 72);
end

--Set minimap(20210129_Fri_updated)
local function SetMinimap()
    if ( not DunningVariables[10] ) then
        return
    end
    for _, name in pairs({TimeManagerClockButton:GetRegions(), MiniMapWorldMapButton, MinimapZoomIn, MinimapZoomOut, MiniMapTracking}) do
        Remove(name);
    end
    MinimapZoneTextButton:SetScript("OnClick", ToggleWorldMap);
    MinimapZoneText:SetWidth(120);
    Move(MinimapZoneTextButton, "LEFT", MinimapCluster, "CENTER", -70, 83);
    Move(MinimapZoneText, "LEFT", MinimapCluster, "CENTER", -70, 83);
    Move(TimeManagerClockButton, "RIGHT", MinimapCluster, "CENTER", 97, 81);
    Move(TimeManagerClockTicker, "RIGHT", MinimapCluster, "CENTER", 86, 83);
    MinimapZoneText:SetFont("Fonts\\2002.TTF", 11);
    TimeManagerClockTicker:SetFont("Fonts\\2002.TTF", 11);
    Minimap:EnableMouseWheel(true);
    Minimap:SetScript("OnMouseWheel", function(self, delta)
            local zoom = Minimap:GetZoom();
            if ( delta > 0 and zoom < 5 ) then
                Minimap:SetZoom(zoom+1);
            elseif ( delta < 0 and zoom > 0 ) then
                Minimap:SetZoom(zoom-1);
            end
    end);
    Minimap:SetScript("OnMouseUp", function(self, button)
            if ( button == "LeftButton" ) then
                Minimap_OnClick(self);
            elseif ( button == "RightButton" ) then
                PlaySound(856);
                ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, "Minimap", -150, 130);
            end
    end);
    local function setup()
        if ( not UnitAffectingCombat("player") ) then
            if (( OrderHallCommandBar ) and ( OrderHallCommandBar:IsShown() )) then
                MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -4, -25);
            else
                MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -4, -4);
            end
        end
    end
    hooksecurefunc("OrderHall_CheckCommandBar", setup);
    setup();
end

--Set bag reverse clean up
SetInsertItemsLeftToRight(true) -- Not a reverse revise "(false)"

--Set hidebags
local function HideBags()
    if ( not DunningVariables[12] ) then
        return
    end
    local function SetSideMenuAlpha(alpha)
        for _, name in pairs({MainMenuBarBackpackButton, CharacterBag0Slot, CharacterBag1Slot, CharacterBag2Slot, CharacterBag3Slot, StatusTrackingBarManager.bars[1], StatusTrackingBarManager.bars[2], StatusTrackingBarManager.bars[3], StatusTrackingBarManager.bars[4], StatusTrackingBarManager.bars[5]}) do
            name:SetAlpha(alpha);
        end
        for i = 1, #MICRO_BUTTONS do
            _G[MICRO_BUTTONS[i]]:SetAlpha(alpha);
        end
    end
    local function setup()
        if ( MainMenuBar:IsShown() ) then
            SetSideMenuAlpha(0);
        else
            SetSideMenuAlpha(1);
        end
    end
    setup();
    hooksecurefunc("MoveMicroButtons", setup);
    for _, name in pairs({MainMenuBarBackpackButton, CharacterBag0Slot, CharacterBag1Slot, CharacterBag2Slot, CharacterBag3Slot, StatusTrackingBarManager.bars[1], StatusTrackingBarManager.bars[2], StatusTrackingBarManager.bars[3], StatusTrackingBarManager.bars[4], StatusTrackingBarManager.bars[5]}) do
        name:HookScript("OnEnter", function(self, motion)
                SetSideMenuAlpha(1);
        end);
        name:HookScript("OnLeave", function(self, motion)
                SetSideMenuAlpha(0);
        end);
    end
    for i = 1, #MICRO_BUTTONS do
        local name = _G[MICRO_BUTTONS[i]];
        name:HookScript("OnEnter", function(self, motion)
                SetSideMenuAlpha(1);
        end);
        name:HookScript("OnLeave", function(self, motion)
                setup();
        end);
    end
end

--Set sticky RAID WARNING
ChatTypeInfo.RAID_WARNING.sticky=1

--Set auto logging combat
local f = CreateFrame("Frame")

f:SetScript("OnEvent", function ()
	local _, instanceType = IsInInstance()
	if instanceType == "raid" then
		if not LoggingCombat() then
			LoggingCombat(true)
			print("DunningUIAutoLogger: |cff00FF00ON|r")
		end
	else
		if LoggingCombat() then
			LoggingCombat(false)
			print("DunningUIAutoLogger: |cffFF0000OFF|r")
		end
	end
end)

SLASH_DunningUIAutoLOGGER1, SLASH_DunningUIAutoLOGGER2 = "/dl"
SlashCmdList.DunningUIAutoLOGGER = function()
	if LoggingCombat() then
		print("DunningUIAutoLogger is |cff00FF00ON|r")
	else
		print("DunningUIAutoLogger is |cffFF0000OFF|r")
	end
end

f:RegisterEvent("PLAYER_ENTERING_WORLD")

--Set hidebossframes
local function hideBossFrames()
	for i = 1, MAX_BOSS_FRAMES do
		local frame = _G["Boss"..i.."TargetFrame"]
		frame:UnregisterAllEvents()
		frame:Hide()
		frame.Show = function() return end
		_G["Boss"..i.."TargetFrame".."HealthBar"]:UnregisterAllEvents()
		_G["Boss"..i.."TargetFrame".."ManaBar"]:UnregisterAllEvents()
	end
end
hideBossFrames()

--Set autosell(20210129_Fri_updated)
local function SetAutoSell()
    local EventFrame = CreateFrame("Frame");
    EventFrame:RegisterEvent("MERCHANT_SHOW");

    local selling, bagsChecked, bagsEmpty;
    local bag, slot, link, count, price, valueInBags, totalMoney;
    local gold, silver, copper, msg;
    local messageType;

    local function SellItems()
        if ( not DunningVariables[5] ) then
            return
        end

        if ( not bagsChecked ) then
            bagsChecked = true;
            valueInBags = 0;
            for bag = 0, 4 do
                for slot = 0, GetContainerNumSlots(bag) do
                    link = GetContainerItemLink(bag, slot);
                    if (( link ) and (select(3, GetItemInfo(link)) == 0) and (select(11, GetItemInfo(link)) > 0)) then
                        count = select(2, GetContainerItemInfo(bag, slot));
                        price = select(11, GetItemInfo(link));
                        valueInBags = price * count + valueInBags;
                    end
                end
            end
        end
        bagsEmpty = true;
        for bag = 0, 4 do
            for slot = 0, GetContainerNumSlots(bag) do
                link = GetContainerItemLink(bag, slot);
                if (( link ) and (select(3, GetItemInfo(link)) == 0) and (select(11, GetItemInfo(link)) > 0)) then
                    if ( selling ) then
                        PickupContainerItem(bag, slot);
                        PickupMerchantItem();
                        bagsEmpty = false;
                    end
                end
            end
        end
        if ( not bagsEmpty ) then
            C_Timer.After(1, SellItems);
            return
        end
        totalMoney = 0;
        for bag = 0, 4 do
            for slot = 0, GetContainerNumSlots(bag) do
                link = GetContainerItemLink(bag, slot);
                if (( link ) and (select(3, GetItemInfo(link)) == 0) and (select(11, GetItemInfo(link)) > 0)) then
                    count = select(2, GetContainerItemInfo(bag, slot));
                    price = select(11, GetItemInfo(link));
                    totalMoney = price * count + totalMoney;
                end
            end
        end
        if ( valueInBags > 0 ) then
            totalMoney = valueInBags - totalMoney;
            gold = floor(abs(totalMoney / 10000));
            silver = floor(abs(mod(totalMoney / 100, 100)));
            copper = floor(abs(mod(totalMoney, 100)));
            msg = format("잡템 판매결과 : %d 골드, %d 실버, %d 코퍼를 받았습니다.", gold, silver, copper);
            DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
        end
    end

    EventFrame:SetScript("OnEvent", function(self, event, ...)
            if ( event == "MERCHANT_SHOW" ) then
                self:UnregisterEvent("MERCHANT_SHOW");
                self:RegisterEvent("MERCHANT_CLOSED");
                self:RegisterEvent("UI_ERROR_MESSAGE");
                bagsChecked = false;
                selling = true;
                SellItems();
            elseif ( event == "MERCHANT_CLOSED" ) then
                self:RegisterEvent("MERCHANT_SHOW");
                self:UnregisterEvent("MERCHANT_CLOSED");
                self:UnregisterEvent("UI_ERROR_MESSAGE");
                selling = false;
            elseif ( event == "UI_ERROR_MESSAGE" ) then
                messageType = ...;
                if ( messageType == 41 ) then
                    self:RegisterEvent("MERCHANT_SHOW");
                    self:UnregisterEvent("MERCHANT_CLOSED");
                    self:UnregisterEvent("UI_ERROR_MESSAGE");
                    selling = false;
                end
            end
    end);
end

--Set item destroyer button
for i=1, STATICPOPUP_NUMDIALOGS do
	local e = _G["StaticPopup"..i.."EditBox"];
	local f = CreateFrame("Button", "$parentDelete", e, "StaticPopupButtonTemplate");
	f:SetSize(62, 21); f:SetPoint("Left","$parent","Right", 10,0);
	f:SetText(DELETE_ITEM_CONFIRM_STRING);
	f:SetScript("OnClick", function()
		e:SetText(DELETE_ITEM_CONFIRM_STRING)
	end)
	e:SetScript("OnShow", function()
	if e:GetParent().which == "DELETE_GOOD_ITEM" then
		f:Show()
	else
		f:Hide()
	end
 end)
end


--Set align
SLASH_EA1 = "/align"

local f

SlashCmdList["EA"] = function()
	if f then
		f:Hide()
		f = nil
	else
		f = CreateFrame('Frame', nil, UIParent)
		f:SetAllPoints(UIParent)
		local w = GetScreenWidth() / 64
		local h = GetScreenHeight() / 36
		for i = 0, 64 do
			local t = f:CreateTexture(nil, 'BACKGROUND')
			if i == 32 then
				t:SetColorTexture(1, 1, 0, 0.5)
			else
				t:SetColorTexture(1, 1, 1, 0.15)
			end
			t:SetPoint('TOPLEFT', f, 'TOPLEFT', i * w - 1, 0)
			t:SetPoint('BOTTOMRIGHT', f, 'BOTTOMLEFT', i * w + 1, 0)
		end
		for i = 0, 36 do
			local t = f:CreateTexture(nil, 'BACKGROUND')
			if i == 18 then
				t:SetColorTexture(1, 1, 0, 0.5)
			else
				t:SetColorTexture(1, 1, 1, 0.15)
			end
			t:SetPoint('TOPLEFT', f, 'TOPLEFT', 0, -i * h + 1)
			t:SetPoint('BOTTOMRIGHT', f, 'TOPRIGHT', 0, -i * h - 1)
		end
	end
end

--Set right click(20210129_Fri_updated)
local function SetRightClick()
    DunningRightClickUpdateDelay = 0;
    WorldFrame:HookScript("OnMouseUp", function(self, button)
            if ( DunningVariables[7] ) then
                if ( button == "RightButton" ) then
                    if ( UnitAffectingCombat("player") ) then
                        if ( DunningRightClickUpdateDelay < GetTime() ) then
                            DunningRightClickUpdateDelay = GetTime()+0.3;
                            MouselookStop();
                        end
                    end
                end
            end
    end);
end

--Set URL copy
local function SetURLCopy()
    for _, name in pairs({"CHAT_MSG_SAY", "CHAT_MSG_WHISPER", "CHAT_MSG_YELL", "CHAT_MSG_GUILD", "CHAT_MSG_OFFICER", "GUILD_MOTD", "CHAT_MSG_BN_WHISPER", "CHAT_MSG_BN_CONVERSATION", "CHAT_MSG_BN_INLINE_TOAST_BROADCAST", "CHAT_MSG_PARTY", "CHAT_MSG_PARTY_LEADER", "CHAT_MSG_RAID", "CHAT_MSG_RAID_LEADER", "CHAT_MSG_INSTANCE_CHAT", "CHAT_MSG_INSTANCE_CHAT_LEADER", "CHAT_MSG_CHANNEL"}) do
        ChatFrame_AddMessageEventFilter(name, function(_, _, msg, ...)
                local newMsg, found = gsub(msg, "[^ \"£%^`¨{}%[%]\\|<>]+[^ '%-=%./,\"£%^`¨{}%[%]\\|<>%d]%.[^ '%-=%./,\"£%^`¨{}%[%]\\|<>%d][^ \"£%^`¨{}%[%]\\|<>]+", "|cff9999ff|Hdunurl~%1|h[%1]|h|r");
                if ( found > 0 ) then
                    return false, newMsg, ...;
                end
                newMsg, found = gsub(msg, "^%x+[%.:]%x+[%.:]%x+[%.:]%x+[^ \"£%^`¨{}%[%]\\|<>]*", "|cff9999ff|Hdunurl~%1|h[%1]|h|r");
                if ( found > 0 ) then
                    return false, newMsg, ...;
                end
                newMsg, found = gsub(msg, " %x+[%.:]%x+[%.:]%x+[%.:]%x+[^ \"£%^`¨{}%[%]\\|<>]*", "|cff9999ff|Hdunurl~%1|h[%1]|h|r");
                if ( found > 0 ) then
                    return false, newMsg, ...;
                end
        end);
    end
    local old = ItemRefTooltip.SetHyperlink;
    function ItemRefTooltip:SetHyperlink(data, ...)
        local isURL, link = strsplit("~", data);
        if (( isURL ) and ( isURL == "dunurl" )) then
            local activeWindow = ChatEdit_GetActiveWindow();
            if ( activeWindow ) then
                activeWindow:SetText(link);
                ChatEdit_FocusActiveWindow();
                activeWindow:HighlightText();
            else
                activeWindow = ChatEdit_GetLastActiveWindow();
                activeWindow:Show();
                activeWindow:SetText(link);
                activeWindow:SetFocus();
                activeWindow:HighlightText();
            end
        else
            old(self, data, ...);
        end
    end
end

--Set hide error messages
local function HideErrorMessages(hide)
    if ( hide ) then
        UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE");
    else
        UIErrorsFrame:RegisterEvent("UI_ERROR_MESSAGE");
    end
end

--Set floating combat text combat text
local function HideFloatingCombatText(hide)
    if ( hide ) then
        ConsoleExec("floatingCombatTextCombatHealing 0");
        ConsoleExec("floatingCombatTextCombatDamage 0");
    else
        ConsoleExec("floatingCombatTextCombatHealing 1");
        ConsoleExec("floatingCombatTextCombatDamage 1");
    end
end

--Set use faster loot
local function UseFasterLoot(activate)
    if ( activate ) then
        if (( GetCVar("autoLootDefault") == "1" ) ~= IsModifiedClick("AUTOLOOTTOGGLE") ) then
            LootFrame:UnregisterEvent("LOOT_OPENED");
        else
            LootFrame:RegisterEvent("LOOT_OPENED");
        end
    else
        LootFrame:RegisterEvent("LOOT_OPENED");
    end
end

--Set slash cmd list
SlashCmdList["RELOAD_RELOADUI"] = function()
    Reload_ReloadUI();
end
	SLASH_RELOAD_RELOADUI1 = "/reload";
	SLASH_RELOAD_RELOADUI2 = "/reloadui";
	SLASH_RELOAD_RELOADUI3 = "/rl";
function Reload_ReloadUI()
	ReloadUI();
end

--OnUpdate
function Coordinates_OnUpdate(self, elapsed)
	timeSinceLastUpdate = timeSinceLastUpdate + elapsed
	if (timeSinceLastUpdate > Coordinates_UpdateInterval) then
		-- Update the update time
		timeSinceLastUpdate = 0
		Coordinates_UpdateCoordinates()
	end
end

--Set minimap coordinates
local Coordinates_UpdateInterval = 0.2
local timeSinceLastUpdate = 0
local color = "|cff00ffff"

local Coordinates_eventFrame = CreateFrame("Frame")
Coordinates_eventFrame:RegisterEvent("VARIABLES_LOADED")
Coordinates_eventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
Coordinates_eventFrame:RegisterEvent("ZONE_CHANGED_INDOORS")
Coordinates_eventFrame:RegisterEvent("ZONE_CHANGED")
Coordinates_eventFrame:SetScript("OnEvent",function(self,event,...) self[event](self,event,...);end)

function Coordinates_eventFrame:VARIABLES_LOADED() --Start event handler
	if (not CoordinatesDB) then
		CoordinatesDB = {}
		CoordinatesDB["minimap"] = true
	end
	Coordinates_eventFrame:SetScript("OnUpdate", function(self, elapsed) Coordinates_OnUpdate(self, elapsed) end)
end

function Coordinates_eventFrame:ZONE_CHANGED_NEW_AREA()
	Coordinates_UpdateCoordinates()
end

function Coordinates_eventFrame:ZONE_CHANGED_INDOORS()
	Coordinates_UpdateCoordinates()
end

function Coordinates_eventFrame:ZONE_CHANGED()
	Coordinates_UpdateCoordinates()
end

function Coordinates_OnUpdate(self, elapsed) --OnUpdate
	timeSinceLastUpdate = timeSinceLastUpdate + elapsed
	if (timeSinceLastUpdate > Coordinates_UpdateInterval) then
		timeSinceLastUpdate = 0 	-- Update the update time
		Coordinates_UpdateCoordinates()
	end
end

function Coordinates_UpdateCoordinates()
	local mapID --MinimapCoordinates
	local position
	if (CoordinatesDB["minimap"] and Minimap:IsVisible()) then
		mapID = C_Map.GetBestMapForUnit("player")
		if (mapID) then
			position = C_Map.GetPlayerMapPosition(mapID,"player")
			if (position and position.x ~= 0 and position.y ~= 0 ) then
				MinimapZoneText:SetText( format("(%d:%d) ",position.x*100.0,position.y*100.0) .. GetMinimapZoneText() );
			end
		end
	end
end

--SetMisc
local function SetMisc()
    -- CastBar
    CastingBarFrame:SetFrameStrata("FULLSCREEN_DIALOG");

    -- RaidFrames
    CompactUnitFrameProfilesGeneralOptionsFrameHeightSlider:SetMinMaxValues(16, 72);

    -- TalkingHeadFrame
    hooksecurefunc("TalkingHead_LoadUI", function()
            TalkingHeadFrame:EnableMouse(false);
    end);

    -- PetJournal
    C_PetJournal.SetPetSortParameter(LE_SORT_BY_RARITY);

    -- Display money received from OpenAllMail
    local totalmoney = 0;
    OpenAllMail.ProcessNextItem = function()
        local _, _, _, _, money, CODAmount, daysLeft, itemCount, _, _, _, _, isGM = GetInboxHeaderInfo(OpenAllMail.mailIndex);
        if ( isGM or (CODAmount and CODAmount > 0) ) then
            OpenAllMail:AdvanceAndProcessNextItem();
            return;
        end
        if ( money > 0 ) then
            TakeInboxMoney(OpenAllMail.mailIndex);
            OpenAllMail.timeUntilNextRetrieval = 0.15;
            totalmoney = totalmoney + money;
        elseif ( itemCount and itemCount > 0 ) then
            TakeInboxItem(OpenAllMail.mailIndex, OpenAllMail.attachmentIndex);
            OpenAllMail.timeUntilNextRetrieval = 0.15;
        else
            OpenAllMail:AdvanceAndProcessNextItem();
        end
    end
    OpenAllMail:SetScript("OnClick", function(self, button, down)
            totalmoney = 0;
            OpenAllMail:StartOpening();
    end);
    OpenAllMail.StopOpening = function()
        if ( totalmoney > 0 ) then
            local gold = floor(abs(totalmoney / 10000));
            local silver = floor(abs(mod(totalmoney / 100, 100)));
            local copper = floor(abs(mod(totalmoney, 100)));
            local msg = format("우편을 통해 %d 골드, %d 실버, %d 코퍼를 받았습니다.", gold, silver, copper);
            DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
            totalmoney = 0;
        end
        OpenAllMail:Reset();
        OpenAllMail:Enable();
        OpenAllMail:SetText(OPEN_ALL_MAIL_BUTTON);
        OpenAllMail:UnregisterEvent("MAIL_INBOX_UPDATE");
        OpenAllMail:UnregisterEvent("MAIL_FAILED");
    end

    -- Close Cinematics without confirmation
    CinematicFrame:HookScript("OnKeyUp", function(self, key)
            if ( key == "ESCAPE" ) then
                if ( CinematicFrame:IsShown() and CinematicFrame.closeDialog and CinematicFrameCloseDialogConfirmButton ) then
                    CinematicFrameCloseDialogConfirmButton:Click();
                end
            end
    end);
    MovieFrame:HookScript("OnKeyUp", function(self, key)
            if ( key == "ESCAPE" ) then
                if ( MovieFrame:IsShown() and MovieFrame.CloseDialog and MovieFrame.CloseDialog.ConfirmButton ) then
                    MovieFrame.CloseDialog.ConfirmButton:Click();
                end
            end
    end);
	
--Creating map coordinate	
local CM = CreateFrame("Frame", nil, WorldMapFrame)
local stimer = 0

CM:SetScript("OnUpdate",function(self, elapsed)
	stimer = stimer + elapsed
	if stimer > 0.2 then
		local cX, cY = WorldMapFrame:GetNormalizedCursorPosition()
		local Coo = "Cursor position : "..format("%0.1f / %0.1f", cX*100, cY*100)
		local viewedMap = WorldMapFrame:GetMapID() or 0
		local pp = C_Map.GetPlayerMapPosition( viewedMap, "player" )
		if pp then
			Coo = Coo.."   Player position : "..format("%0.1f / %0.1f", pp.x*100, pp.y*100)
			WorldMapFrame.BorderFrame.TitleText:SetText(Coo)
		end
		stimer = 0
	end
end)

end

--Set ClassColor
local function colour(statusbar, unit) --Create unitisplayer class color
        local _, class, c
        if UnitIsPlayer(unit) and UnitIsConnected(unit) and unit == statusbar.unit and UnitClass(unit) then
                _, class = UnitClass(unit)
                c = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class] or RAID_CLASS_COLORS[class]
                statusbar:SetStatusBarColor(c.r, c.g, c.b)        end
end
hooksecurefunc("UnitFrameHealthBar_Update", colour)
hooksecurefunc("HealthBar_OnValueChanged", function(self)
        colour(self, self.unit)
end)
local frame = CreateFrame("FRAME")
frame:RegisterEvent("GROUP_ROSTER_UPDATE")
frame:RegisterEvent("PLAYER_TARGET_CHANGED")
frame:RegisterEvent("PLAYER_FOCUS_CHANGED")
frame:RegisterEvent("UNIT_FACTION")
local function eventHandler(self, event, ...)
    if UnitIsPlayer("target") then
        c = RAID_CLASS_COLORS[select(2, UnitClass("target"))]
        TargetFrameNameBackground:SetVertexColor(c.r, c.g, c.b)
    end
    if UnitIsPlayer("focus") then
        c = RAID_CLASS_COLORS[select(2, UnitClass("focus"))]
        FocusFrameNameBackground:SetVertexColor(c.r, c.g, c.b)
    end
    if PlayerFrame:IsShown() and not PlayerFrame.bg then
        c = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
        bg=PlayerFrame:CreateTexture()
        bg:SetPoint("TOPLEFT",PlayerFrameBackground)
        bg:SetPoint("BOTTOMRIGHT",PlayerFrameBackground,0,22)
        bg:SetTexture(TargetFrameNameBackground:GetTexture())
        bg:SetVertexColor(c.r,c.g,c.b)
        PlayerFrame.bg=true
    end
end
frame:SetScript("OnEvent", eventHandler)
hooksecurefunc("HealthBar_OnValueChanged", function (self) --Create healthBar class color
	if UnitIsPlayer(self.unit) then
		local c = RAID_CLASS_COLORS[select(2,UnitClass(self.unit))];
		if c then
			self:SetStatusBarColor(c.r, c.g, c.b)
		end
	end
end);

hooksecurefunc("UnitFrameHealthBar_Update", function (self) --Create unit frame health bar class color
	if UnitIsPlayer(self.unit) then
		local c = RAID_CLASS_COLORS[select(2,UnitClass(self.unit))];
		if c then
			self:SetStatusBarColor(c.r, c.g, c.b)
		end
	end
end);

--SetOptionsframe
local function SetOptionsframe()
    CreateFrame("Frame", "DunningVariablesInterface");
    DunningVariablesInterface.name = "DunningUI";
    InterfaceOptions_AddCategory(DunningVariablesInterface);
    SlashCmdList["DunningSlash"] = function(DunningVariables)
        InterfaceOptionsFrame:Show();
        InterfaceOptionsFrame_OpenToCategory("DunningUI");
    end;
    SLASH_DunningSlash1 = "/dui";
    DunningSettings = {
        [2] = {x = 24, y = 50+35*1, Text = "에러 메세지 숨김"},
        [11] = {x = 24, y = 50+35*2, Text = "전투 메세지 숨김"},
        [3] = {x = 24, y = 50+35*3, Text = "개인 골드 자동수리"},
        [4] = {x = 174, y = 50+35*3, Text = "길드 골드 자동수리"},
        [5] = {x = 24, y = 50+35*4, Text = "자동 흰색 아이템 판매"},
        [8] = {x = 24, y = 50+35*5, Text = "자동 퀘스트 받기"},
        [9] = {x = 24, y = 60+35*6, Text = "빠른 자동 룻"},
        [7] = {x = 24, y = 70+35*7, Text = "전투중 마우스 클릭 상호작용 방지"},
        [1] = {x = 24, y = 130+35*8, Text = "네임 플레이트"},
        [10] = {x = 174, y = 130+35*8, Text = "미니맵"},
        [14] = {x = 324, y = 130+35*8, Text = "채팅"},
        [15] = {x = 24, y = 130+35*9, Text = "유닛 프레임"},
        [13] = {x = 174, y = 130+35*9, Text = "메인 메뉴 & 액션바"},
        [12] = {x = 24, y = 130+35*10, Text = "가방과 마이크로 버튼 숨기기"},
    };
    local box = {};
    for i = 1, #DunningSettings do
        if ( DunningSettings[i] ) then
            box[i] = CreateFrame("CheckButton", "box"..i, DunningVariablesInterface, "InterfaceOptionsCheckButtonTemplate");
            Move(box[i], "TOPLEFT", DunningVariablesInterface, "TOPLEFT", DunningSettings[i]["x"], -DunningSettings[i]["y"]);
            box[i]:SetChecked(DunningVariables[i]);
            _G[box[i]:GetName().."Text"]:SetText(DunningSettings[i]["Text"]);
            box[i]:SetScript("OnClick", function(self, button, down)
                    DunningVariables[i] = self:GetChecked();
            end);
            DunningVariablesInterface:SetScript("OnShow", function(self)
                    for i = 1, #DunningSettings do
                        if ( box[i] ) then
                            box[i]:SetChecked(DunningVariables[i]);
                        end
                    end
            end);
        end
    end
    box[2]:HookScript("OnClick", function(self, button, down)
            HideErrorMessages(DunningVariables[2]);
    end);
    box[11]:HookScript("OnClick", function(self, button, down)
            HideFloatingCombatText(DunningVariables[11]);
    end);
    box[9]:HookScript("OnClick", function(self, button, down)
            UseFasterLoot(DunningVariables[9]);
    end);
    local text1 = DunningVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
    local text2 = DunningVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
    local text3 = DunningVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontNormal");
    local text4 = DunningVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontNormal");
    local text5 = DunningVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
    local text6 = DunningVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
    local text7 = DunningVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
    local text8 = DunningVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
    text1:SetText("더닝 UI");
    text2:SetText("UI의 편의성과 가벼움에 중점을 두고 제작, 아즈샤라 서버 타우렌 호드 더닝, https://dunui.tistory.com/");
    text3:SetText("옵션 설정");
    text4:SetText("인터페이스 사용자 설정");
    text5:SetText("모든 설정의 원활한 적용을 위해 UI 다시 불러오기가 필요합니다.");
    text6:SetText("전투중 룻, 대상선택, 카메라 시점 전환등 실수로 인한 마우스 클릭을 방지합니다.");
    text7:SetText("일시적으로 시프트 키 누름 효과를 적용합니다.");
    text8:SetText("자동 루팅시 아이템 창을 표시하지 않습니다.");
    text6:SetJustifyH("LEFT");
    text1:SetPoint("TOPLEFT", 16, -16);
    text2:SetPoint("TOPLEFT", text1, "BOTTOMLEFT", 0, -8);
    text3:SetPoint("BOTTOMLEFT", box[2], "TOPLEFT", 0, 8);
    text4:SetPoint("BOTTOMLEFT", text5, "TOPLEFT", 0, 8);
    text5:SetPoint("BOTTOMLEFT", box[1], "TOPLEFT", 0, 8);
    text6:SetPoint("TOPLEFT", box[7], "BOTTOMLEFT", 40, 2);
    text7:SetPoint("TOPLEFT", box[8], "BOTTOMLEFT", 40, 2);
    text8:SetPoint("TOPLEFT", box[9], "BOTTOMLEFT", 40, 2);
    local b = CreateFrame("Button", nil, DunningVariablesInterface, "UIPanelButtonTemplate");
    b:SetSize(100, 22);
    b:SetText("UI 다시 불러오기");
    b:SetPoint("BOTTOMRIGHT", -16, 16);
    b:SetScript("OnClick", function(self, button, down)
            ReloadUI();
    end)
end

--Set EventHandler
local function EventHandler(self, event, ...)
    if ( event == "MERCHANT_SHOW" ) then
        if ( CanMerchantRepair() ) then
            local cost = GetRepairAllCost();
            if ( cost > 0 ) then
                local done = false;
                if ( IsInGuild() ) and ( CanGuildBankRepair() ) then
                    if ( cost <= GetGuildBankWithdrawMoney() ) then
                        if ( DunningVariables[4] ) then
                            done = true;
                            RepairAllItems(1);
                        end
                    end
                end
                if ( DunningVariables[3] and not done ) then
                    RepairAllItems();
                end
            end
        end
    elseif ( event == "MODIFIER_STATE_CHANGED" ) then
        if ( DunningVariables[9] ) then
            UseFasterLoot(true);
        end
    elseif ( event == "LOOT_OPENED" ) then
        if ( DunningVariables[9] ) then
            auto = ...;
            if ( auto == 1 ) then
                for i = 0, GetNumLootItems(), 1 do
                    LootSlot(i);
                end
            end
        end
    elseif (( event == "AUCTION_HOUSE_SHOW" ) or ( event == "BANKFRAME_OPENED" ) or ( event == "GUILDBANKFRAME_OPENED" ) or ( event == "VOID_STORAGE_OPEN" ) or ( event == "SCRAPPING_MACHINE_SHOW" )) then
        CloseAllBags();
        OpenAllBags();
        if ( event == "BANKFRAME_OPENED" ) then
            local numSlots = GetNumBankSlots();
            for i = 0, numSlots do
                OpenBag(NUM_BAG_SLOTS + 1 + i);
            end
        end
    elseif (( DunningVariables[8] ) and ( not IsShiftKeyDown() )) then
        if ( event == "QUEST_DETAIL" ) then
            if ( not QuestGetAutoAccept() ) then
                AcceptQuest();
            else
                CloseQuest();
            end
        end
        if ( event == "QUEST_ACCEPT_CONFIRM" ) then
            ConfirmAcceptQuest();
            StaticPopup_Hide("QUEST_ACCEPT_CONFIRM");
        end
        if ( event == "QUEST_PROGRESS" ) then
            if ( IsQuestCompletable() ) then
                CompleteQuest();
            end
        end
        if ( event == "QUEST_COMPLETE" ) then
            if ( GetNumQuestChoices() <= 1 ) then
                GetQuestReward(GetNumQuestChoices());
            end
        end
    end
end

--Set LoadAddon
local function LoadAddon(self, event, ...)
    EventWatcher:UnregisterAllEvents();
    SetMainMenu();
    SetChatframes();
    SetUnitframes();
    SetMinimap();
    HideBags();
    SetAutoSell();
    SetRightClick();
    SetURLCopy();
    SetMisc();
    SetOptionsframe();
    HideErrorMessages(DunningVariables[2]);
    HideFloatingCombatText(DunningVariables[11]);
    UseFasterLoot(DunningVariables[9]);
    EventWatcher:SetScript("OnEvent", EventHandler);
    EventWatcher:RegisterEvent("MERCHANT_SHOW");
    EventWatcher:RegisterEvent("LOOT_OPENED");
    EventWatcher:RegisterEvent("MODIFIER_STATE_CHANGED");
    EventWatcher:RegisterEvent("QUEST_DETAIL");
    EventWatcher:RegisterEvent("QUEST_ACCEPT_CONFIRM");
    EventWatcher:RegisterEvent("QUEST_PROGRESS");
    EventWatcher:RegisterEvent("QUEST_COMPLETE");
    EventWatcher:RegisterEvent("AUCTION_HOUSE_SHOW");
    EventWatcher:RegisterEvent("BANKFRAME_OPENED");
    EventWatcher:RegisterEvent("GUILDBANKFRAME_OPENED");
    EventWatcher:RegisterEvent("VOID_STORAGE_OPEN");
    EventWatcher:RegisterEvent("SCRAPPING_MACHINE_SHOW");
    collectgarbage();
end

--Set LoginEvent
local function LoginEvent(self, event, ...)
    EventWatcher:UnregisterAllEvents();
    if (( not DunningVariables ) or (( DunningVariables ) and ( type(DunningVariables) ~= "table" )) or ( DunningVariables[0] ~= 1.40 )) then
        print('더닝 UI가 모든 옵션값을 초기화 했습니다. "/dui"를 타이핑하여 셋팅값을 설정하세요!');
        DunningVariables = {[0] = 1.40, [1] = 1, [3] = 1, [5] = 1, [8] = 1, [10] = 1, [13] = 1, [14] = 1, [15] = 1,};
    end
    SetNameplates(); -- Can be loaded in combat. Needs to be loaded before the first nameplate is loaded.
    if ( UnitAffectingCombat("player") ) then
        EventWatcher:SetScript("OnEvent", LoadAddon);
        EventWatcher:RegisterEvent("PLAYER_REGEN_ENABLED");
    else
        LoadAddon();
    end
end
EventWatcher:SetScript("OnEvent", LoginEvent);
EventWatcher:RegisterEvent("PLAYER_ENTERING_WORLD");